/* Modulo de rvores binrias (com chaves inteiras)  */

typedef int KeyType;     

typedef struct treeEntry{
  KeyType key;
  void *value;
} TreeEntry;  
   

typedef struct treeNode{
  TreeEntry entry;
  struct treeNode *left;
  struct treeNode *right;
} TreeNode;


typedef TreeNode *Tree;


// cria uma rvore vazia
Tree treeCreate(void);

// testa se a rvore  vazia 
int treeEmpty(Tree);

// conta o nmero de nodos da rvore
int treeSize(Tree);

// calcula a altura da rvore
int treeHeight(Tree);

// apaga toda rvore
void treeClear(Tree *);


// travessias
void treePreorder(Tree,void (*fun)(KeyType, void*));
void treeInorder(Tree,void (*fun)(KeyType, void*));
void treePostorder(Tree,void (*fun)(KeyType, void*));


// testa se a rvore binria est completa
int treeComplete(Tree);  

// procedimento que cria uma cpia da rvore binria
void treeCopy(Tree,Tree *); 

// funo que cria uma cpia da rvore binria
Tree treeCopyRoot(Tree);



// RVORES BINRIAS DE PROCURA

// insere um novo elemento numa rvore binria de procura.
// (obs: substitui o valor se a chave j existir
Tree treeInsert(Tree, KeyType, void *);


// procura um elemento numa rvore binria de procura (RECURSIVA)
void *treeSearch(Tree, KeyType);

// procura um elemento numa rvore binria de procura (ITERATIVA)
void *treeSearchIT(Tree, KeyType);


// remove um elemento (com uma dada chave) de uma rvore binria de procura.
void treeDeleteKey(Tree *, KeyType);

// remove o nodo que est na raiz de uma rvore binria de procura.
void treeDeleteRoot(Tree *);


// actualiza a informao associada a uma chave numa rvore binria de procura.
Tree treeChange(Tree, KeyType, void*);

