/* 
   Mdulo de "Funes Finitas" (maps) implementados sobre rvores binrias
   de procura com chaves inteiras.
*/


#include "BinTree.h"


typedef Tree TreeMapInt;


/*
  Cria um novo Map
*/
TreeMapInt mapCreate(void);


/*
  Adiciona uma associao "(chave, valor)" a um Map.
  (obs.: substitui associao se a chave j pertencer ao domnio do Map)
*/
void mapPut(TreeMapInt* map, KeyType key, void *value);


/*
  Retorna valor associado a uma chave (NULL se a chave no pertencer ao
  domnio).
*/
void *mapGet(TreeMapInt map, KeyType key);


/*
  Itera a aplicao da funo "procEntry" por todos os pares "(chave,valor)"
  contidos no Map.
*/
void mapIter(TreeMapInt map, void (*procEntry)(KeyType, void*));

/*
  Apaga todas as associaes "(chave, valor)" a um Map.
*/
void mapClear(TreeMapInt *map);
